/*eslint-disable block-scoped-var, id-length, no-control-regex, no-magic-numbers, no-prototype-builtins, no-redeclare, no-shadow, no-var, sort-vars*/
"use strict";

var $protobuf = require("protobufjs/minimal");

// Common aliases
var $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;

// Exported root namespace
var $root = $protobuf.roots["default"] || ($protobuf.roots["default"] = {});

$root.UserId = (function() {

    /**
     * Properties of a UserId.
     * @exports IUserId
     * @interface IUserId
     * @property {Uint8Array} uuid UserId uuid
     */

    /**
     * Constructs a new UserId.
     * @exports UserId
     * @classdesc Represents a UserId.
     * @implements IUserId
     * @constructor
     * @param {IUserId=} [properties] Properties to set
     */
    function UserId(properties) {
        if (properties)
            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                if (properties[keys[i]] != null)
                    this[keys[i]] = properties[keys[i]];
    }

    /**
     * UserId uuid.
     * @member {Uint8Array} uuid
     * @memberof UserId
     * @instance
     */
    UserId.prototype.uuid = $util.newBuffer([]);

    /**
     * Creates a new UserId instance using the specified properties.
     * @function create
     * @memberof UserId
     * @static
     * @param {IUserId=} [properties] Properties to set
     * @returns {UserId} UserId instance
     */
    UserId.create = function create(properties) {
        return new UserId(properties);
    };

    /**
     * Encodes the specified UserId message. Does not implicitly {@link UserId.verify|verify} messages.
     * @function encode
     * @memberof UserId
     * @static
     * @param {IUserId} message UserId message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    UserId.encode = function encode(message, writer) {
        if (!writer)
            writer = $Writer.create();
        writer.uint32(/* id 1, wireType 2 =*/10).bytes(message.uuid);
        return writer;
    };

    /**
     * Encodes the specified UserId message, length delimited. Does not implicitly {@link UserId.verify|verify} messages.
     * @function encodeDelimited
     * @memberof UserId
     * @static
     * @param {IUserId} message UserId message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    UserId.encodeDelimited = function encodeDelimited(message, writer) {
        return this.encode(message, writer).ldelim();
    };

    /**
     * Decodes a UserId message from the specified reader or buffer.
     * @function decode
     * @memberof UserId
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @param {number} [length] Message length if known beforehand
     * @returns {UserId} UserId
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    UserId.decode = function decode(reader, length) {
        if (!(reader instanceof $Reader))
            reader = $Reader.create(reader);
        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.UserId();
        while (reader.pos < end) {
            var tag = reader.uint32();
            switch (tag >>> 3) {
            case 1:
                message.uuid = reader.bytes();
                break;
            default:
                reader.skipType(tag & 7);
                break;
            }
        }
        if (!message.hasOwnProperty("uuid"))
            throw $util.ProtocolError("missing required 'uuid'", { instance: message });
        return message;
    };

    /**
     * Decodes a UserId message from the specified reader or buffer, length delimited.
     * @function decodeDelimited
     * @memberof UserId
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @returns {UserId} UserId
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    UserId.decodeDelimited = function decodeDelimited(reader) {
        if (!(reader instanceof $Reader))
            reader = new $Reader(reader);
        return this.decode(reader, reader.uint32());
    };

    /**
     * Verifies a UserId message.
     * @function verify
     * @memberof UserId
     * @static
     * @param {Object.<string,*>} message Plain object to verify
     * @returns {string|null} `null` if valid, otherwise the reason why it is not
     */
    UserId.verify = function verify(message) {
        if (typeof message !== "object" || message === null)
            return "object expected";
        if (!(message.uuid && typeof message.uuid.length === "number" || $util.isString(message.uuid)))
            return "uuid: buffer expected";
        return null;
    };

    /**
     * Creates a UserId message from a plain object. Also converts values to their respective internal types.
     * @function fromObject
     * @memberof UserId
     * @static
     * @param {Object.<string,*>} object Plain object
     * @returns {UserId} UserId
     */
    UserId.fromObject = function fromObject(object) {
        if (object instanceof $root.UserId)
            return object;
        var message = new $root.UserId();
        if (object.uuid != null)
            if (typeof object.uuid === "string")
                $util.base64.decode(object.uuid, message.uuid = $util.newBuffer($util.base64.length(object.uuid)), 0);
            else if (object.uuid.length)
                message.uuid = object.uuid;
        return message;
    };

    /**
     * Creates a plain object from a UserId message. Also converts values to other types if specified.
     * @function toObject
     * @memberof UserId
     * @static
     * @param {UserId} message UserId
     * @param {$protobuf.IConversionOptions} [options] Conversion options
     * @returns {Object.<string,*>} Plain object
     */
    UserId.toObject = function toObject(message, options) {
        if (!options)
            options = {};
        var object = {};
        if (options.defaults)
            if (options.bytes === String)
                object.uuid = "";
            else {
                object.uuid = [];
                if (options.bytes !== Array)
                    object.uuid = $util.newBuffer(object.uuid);
            }
        if (message.uuid != null && message.hasOwnProperty("uuid"))
            object.uuid = options.bytes === String ? $util.base64.encode(message.uuid, 0, message.uuid.length) : options.bytes === Array ? Array.prototype.slice.call(message.uuid) : message.uuid;
        return object;
    };

    /**
     * Converts this UserId to JSON.
     * @function toJSON
     * @memberof UserId
     * @instance
     * @returns {Object.<string,*>} JSON object
     */
    UserId.prototype.toJSON = function toJSON() {
        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
    };

    return UserId;
})();

$root.ClientId = (function() {

    /**
     * Properties of a ClientId.
     * @exports IClientId
     * @interface IClientId
     * @property {number|Long} client ClientId client
     */

    /**
     * Constructs a new ClientId.
     * @exports ClientId
     * @classdesc Represents a ClientId.
     * @implements IClientId
     * @constructor
     * @param {IClientId=} [properties] Properties to set
     */
    function ClientId(properties) {
        if (properties)
            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                if (properties[keys[i]] != null)
                    this[keys[i]] = properties[keys[i]];
    }

    /**
     * ClientId client.
     * @member {number|Long} client
     * @memberof ClientId
     * @instance
     */
    ClientId.prototype.client = $util.Long ? $util.Long.fromBits(0,0,true) : 0;

    /**
     * Creates a new ClientId instance using the specified properties.
     * @function create
     * @memberof ClientId
     * @static
     * @param {IClientId=} [properties] Properties to set
     * @returns {ClientId} ClientId instance
     */
    ClientId.create = function create(properties) {
        return new ClientId(properties);
    };

    /**
     * Encodes the specified ClientId message. Does not implicitly {@link ClientId.verify|verify} messages.
     * @function encode
     * @memberof ClientId
     * @static
     * @param {IClientId} message ClientId message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    ClientId.encode = function encode(message, writer) {
        if (!writer)
            writer = $Writer.create();
        writer.uint32(/* id 1, wireType 0 =*/8).uint64(message.client);
        return writer;
    };

    /**
     * Encodes the specified ClientId message, length delimited. Does not implicitly {@link ClientId.verify|verify} messages.
     * @function encodeDelimited
     * @memberof ClientId
     * @static
     * @param {IClientId} message ClientId message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    ClientId.encodeDelimited = function encodeDelimited(message, writer) {
        return this.encode(message, writer).ldelim();
    };

    /**
     * Decodes a ClientId message from the specified reader or buffer.
     * @function decode
     * @memberof ClientId
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @param {number} [length] Message length if known beforehand
     * @returns {ClientId} ClientId
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    ClientId.decode = function decode(reader, length) {
        if (!(reader instanceof $Reader))
            reader = $Reader.create(reader);
        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.ClientId();
        while (reader.pos < end) {
            var tag = reader.uint32();
            switch (tag >>> 3) {
            case 1:
                message.client = reader.uint64();
                break;
            default:
                reader.skipType(tag & 7);
                break;
            }
        }
        if (!message.hasOwnProperty("client"))
            throw $util.ProtocolError("missing required 'client'", { instance: message });
        return message;
    };

    /**
     * Decodes a ClientId message from the specified reader or buffer, length delimited.
     * @function decodeDelimited
     * @memberof ClientId
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @returns {ClientId} ClientId
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    ClientId.decodeDelimited = function decodeDelimited(reader) {
        if (!(reader instanceof $Reader))
            reader = new $Reader(reader);
        return this.decode(reader, reader.uint32());
    };

    /**
     * Verifies a ClientId message.
     * @function verify
     * @memberof ClientId
     * @static
     * @param {Object.<string,*>} message Plain object to verify
     * @returns {string|null} `null` if valid, otherwise the reason why it is not
     */
    ClientId.verify = function verify(message) {
        if (typeof message !== "object" || message === null)
            return "object expected";
        if (!$util.isInteger(message.client) && !(message.client && $util.isInteger(message.client.low) && $util.isInteger(message.client.high)))
            return "client: integer|Long expected";
        return null;
    };

    /**
     * Creates a ClientId message from a plain object. Also converts values to their respective internal types.
     * @function fromObject
     * @memberof ClientId
     * @static
     * @param {Object.<string,*>} object Plain object
     * @returns {ClientId} ClientId
     */
    ClientId.fromObject = function fromObject(object) {
        if (object instanceof $root.ClientId)
            return object;
        var message = new $root.ClientId();
        if (object.client != null)
            if ($util.Long)
                (message.client = $util.Long.fromValue(object.client)).unsigned = true;
            else if (typeof object.client === "string")
                message.client = parseInt(object.client, 10);
            else if (typeof object.client === "number")
                message.client = object.client;
            else if (typeof object.client === "object")
                message.client = new $util.LongBits(object.client.low >>> 0, object.client.high >>> 0).toNumber(true);
        return message;
    };

    /**
     * Creates a plain object from a ClientId message. Also converts values to other types if specified.
     * @function toObject
     * @memberof ClientId
     * @static
     * @param {ClientId} message ClientId
     * @param {$protobuf.IConversionOptions} [options] Conversion options
     * @returns {Object.<string,*>} Plain object
     */
    ClientId.toObject = function toObject(message, options) {
        if (!options)
            options = {};
        var object = {};
        if (options.defaults)
            if ($util.Long) {
                var long = new $util.Long(0, 0, true);
                object.client = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
            } else
                object.client = options.longs === String ? "0" : 0;
        if (message.client != null && message.hasOwnProperty("client"))
            if (typeof message.client === "number")
                object.client = options.longs === String ? String(message.client) : message.client;
            else
                object.client = options.longs === String ? $util.Long.prototype.toString.call(message.client) : options.longs === Number ? new $util.LongBits(message.client.low >>> 0, message.client.high >>> 0).toNumber(true) : message.client;
        return object;
    };

    /**
     * Converts this ClientId to JSON.
     * @function toJSON
     * @memberof ClientId
     * @instance
     * @returns {Object.<string,*>} JSON object
     */
    ClientId.prototype.toJSON = function toJSON() {
        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
    };

    return ClientId;
})();

$root.ClientEntry = (function() {

    /**
     * Properties of a ClientEntry.
     * @exports IClientEntry
     * @interface IClientEntry
     * @property {IClientId} client ClientEntry client
     * @property {Uint8Array} text ClientEntry text
     */

    /**
     * Constructs a new ClientEntry.
     * @exports ClientEntry
     * @classdesc Represents a ClientEntry.
     * @implements IClientEntry
     * @constructor
     * @param {IClientEntry=} [properties] Properties to set
     */
    function ClientEntry(properties) {
        if (properties)
            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                if (properties[keys[i]] != null)
                    this[keys[i]] = properties[keys[i]];
    }

    /**
     * ClientEntry client.
     * @member {IClientId} client
     * @memberof ClientEntry
     * @instance
     */
    ClientEntry.prototype.client = null;

    /**
     * ClientEntry text.
     * @member {Uint8Array} text
     * @memberof ClientEntry
     * @instance
     */
    ClientEntry.prototype.text = $util.newBuffer([]);

    /**
     * Creates a new ClientEntry instance using the specified properties.
     * @function create
     * @memberof ClientEntry
     * @static
     * @param {IClientEntry=} [properties] Properties to set
     * @returns {ClientEntry} ClientEntry instance
     */
    ClientEntry.create = function create(properties) {
        return new ClientEntry(properties);
    };

    /**
     * Encodes the specified ClientEntry message. Does not implicitly {@link ClientEntry.verify|verify} messages.
     * @function encode
     * @memberof ClientEntry
     * @static
     * @param {IClientEntry} message ClientEntry message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    ClientEntry.encode = function encode(message, writer) {
        if (!writer)
            writer = $Writer.create();
        $root.ClientId.encode(message.client, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
        writer.uint32(/* id 2, wireType 2 =*/18).bytes(message.text);
        return writer;
    };

    /**
     * Encodes the specified ClientEntry message, length delimited. Does not implicitly {@link ClientEntry.verify|verify} messages.
     * @function encodeDelimited
     * @memberof ClientEntry
     * @static
     * @param {IClientEntry} message ClientEntry message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    ClientEntry.encodeDelimited = function encodeDelimited(message, writer) {
        return this.encode(message, writer).ldelim();
    };

    /**
     * Decodes a ClientEntry message from the specified reader or buffer.
     * @function decode
     * @memberof ClientEntry
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @param {number} [length] Message length if known beforehand
     * @returns {ClientEntry} ClientEntry
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    ClientEntry.decode = function decode(reader, length) {
        if (!(reader instanceof $Reader))
            reader = $Reader.create(reader);
        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.ClientEntry();
        while (reader.pos < end) {
            var tag = reader.uint32();
            switch (tag >>> 3) {
            case 1:
                message.client = $root.ClientId.decode(reader, reader.uint32());
                break;
            case 2:
                message.text = reader.bytes();
                break;
            default:
                reader.skipType(tag & 7);
                break;
            }
        }
        if (!message.hasOwnProperty("client"))
            throw $util.ProtocolError("missing required 'client'", { instance: message });
        if (!message.hasOwnProperty("text"))
            throw $util.ProtocolError("missing required 'text'", { instance: message });
        return message;
    };

    /**
     * Decodes a ClientEntry message from the specified reader or buffer, length delimited.
     * @function decodeDelimited
     * @memberof ClientEntry
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @returns {ClientEntry} ClientEntry
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    ClientEntry.decodeDelimited = function decodeDelimited(reader) {
        if (!(reader instanceof $Reader))
            reader = new $Reader(reader);
        return this.decode(reader, reader.uint32());
    };

    /**
     * Verifies a ClientEntry message.
     * @function verify
     * @memberof ClientEntry
     * @static
     * @param {Object.<string,*>} message Plain object to verify
     * @returns {string|null} `null` if valid, otherwise the reason why it is not
     */
    ClientEntry.verify = function verify(message) {
        if (typeof message !== "object" || message === null)
            return "object expected";
        {
            var error = $root.ClientId.verify(message.client);
            if (error)
                return "client." + error;
        }
        if (!(message.text && typeof message.text.length === "number" || $util.isString(message.text)))
            return "text: buffer expected";
        return null;
    };

    /**
     * Creates a ClientEntry message from a plain object. Also converts values to their respective internal types.
     * @function fromObject
     * @memberof ClientEntry
     * @static
     * @param {Object.<string,*>} object Plain object
     * @returns {ClientEntry} ClientEntry
     */
    ClientEntry.fromObject = function fromObject(object) {
        if (object instanceof $root.ClientEntry)
            return object;
        var message = new $root.ClientEntry();
        if (object.client != null) {
            if (typeof object.client !== "object")
                throw TypeError(".ClientEntry.client: object expected");
            message.client = $root.ClientId.fromObject(object.client);
        }
        if (object.text != null)
            if (typeof object.text === "string")
                $util.base64.decode(object.text, message.text = $util.newBuffer($util.base64.length(object.text)), 0);
            else if (object.text.length)
                message.text = object.text;
        return message;
    };

    /**
     * Creates a plain object from a ClientEntry message. Also converts values to other types if specified.
     * @function toObject
     * @memberof ClientEntry
     * @static
     * @param {ClientEntry} message ClientEntry
     * @param {$protobuf.IConversionOptions} [options] Conversion options
     * @returns {Object.<string,*>} Plain object
     */
    ClientEntry.toObject = function toObject(message, options) {
        if (!options)
            options = {};
        var object = {};
        if (options.defaults) {
            object.client = null;
            if (options.bytes === String)
                object.text = "";
            else {
                object.text = [];
                if (options.bytes !== Array)
                    object.text = $util.newBuffer(object.text);
            }
        }
        if (message.client != null && message.hasOwnProperty("client"))
            object.client = $root.ClientId.toObject(message.client, options);
        if (message.text != null && message.hasOwnProperty("text"))
            object.text = options.bytes === String ? $util.base64.encode(message.text, 0, message.text.length) : options.bytes === Array ? Array.prototype.slice.call(message.text) : message.text;
        return object;
    };

    /**
     * Converts this ClientEntry to JSON.
     * @function toJSON
     * @memberof ClientEntry
     * @instance
     * @returns {Object.<string,*>} JSON object
     */
    ClientEntry.prototype.toJSON = function toJSON() {
        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
    };

    return ClientEntry;
})();

$root.UserEntry = (function() {

    /**
     * Properties of a UserEntry.
     * @exports IUserEntry
     * @interface IUserEntry
     * @property {IUserId} user UserEntry user
     * @property {Array.<IClientEntry>|null} [clients] UserEntry clients
     */

    /**
     * Constructs a new UserEntry.
     * @exports UserEntry
     * @classdesc Represents a UserEntry.
     * @implements IUserEntry
     * @constructor
     * @param {IUserEntry=} [properties] Properties to set
     */
    function UserEntry(properties) {
        this.clients = [];
        if (properties)
            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                if (properties[keys[i]] != null)
                    this[keys[i]] = properties[keys[i]];
    }

    /**
     * UserEntry user.
     * @member {IUserId} user
     * @memberof UserEntry
     * @instance
     */
    UserEntry.prototype.user = null;

    /**
     * UserEntry clients.
     * @member {Array.<IClientEntry>} clients
     * @memberof UserEntry
     * @instance
     */
    UserEntry.prototype.clients = $util.emptyArray;

    /**
     * Creates a new UserEntry instance using the specified properties.
     * @function create
     * @memberof UserEntry
     * @static
     * @param {IUserEntry=} [properties] Properties to set
     * @returns {UserEntry} UserEntry instance
     */
    UserEntry.create = function create(properties) {
        return new UserEntry(properties);
    };

    /**
     * Encodes the specified UserEntry message. Does not implicitly {@link UserEntry.verify|verify} messages.
     * @function encode
     * @memberof UserEntry
     * @static
     * @param {IUserEntry} message UserEntry message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    UserEntry.encode = function encode(message, writer) {
        if (!writer)
            writer = $Writer.create();
        $root.UserId.encode(message.user, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
        if (message.clients != null && message.clients.length)
            for (var i = 0; i < message.clients.length; ++i)
                $root.ClientEntry.encode(message.clients[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
        return writer;
    };

    /**
     * Encodes the specified UserEntry message, length delimited. Does not implicitly {@link UserEntry.verify|verify} messages.
     * @function encodeDelimited
     * @memberof UserEntry
     * @static
     * @param {IUserEntry} message UserEntry message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    UserEntry.encodeDelimited = function encodeDelimited(message, writer) {
        return this.encode(message, writer).ldelim();
    };

    /**
     * Decodes a UserEntry message from the specified reader or buffer.
     * @function decode
     * @memberof UserEntry
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @param {number} [length] Message length if known beforehand
     * @returns {UserEntry} UserEntry
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    UserEntry.decode = function decode(reader, length) {
        if (!(reader instanceof $Reader))
            reader = $Reader.create(reader);
        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.UserEntry();
        while (reader.pos < end) {
            var tag = reader.uint32();
            switch (tag >>> 3) {
            case 1:
                message.user = $root.UserId.decode(reader, reader.uint32());
                break;
            case 2:
                if (!(message.clients && message.clients.length))
                    message.clients = [];
                message.clients.push($root.ClientEntry.decode(reader, reader.uint32()));
                break;
            default:
                reader.skipType(tag & 7);
                break;
            }
        }
        if (!message.hasOwnProperty("user"))
            throw $util.ProtocolError("missing required 'user'", { instance: message });
        return message;
    };

    /**
     * Decodes a UserEntry message from the specified reader or buffer, length delimited.
     * @function decodeDelimited
     * @memberof UserEntry
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @returns {UserEntry} UserEntry
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    UserEntry.decodeDelimited = function decodeDelimited(reader) {
        if (!(reader instanceof $Reader))
            reader = new $Reader(reader);
        return this.decode(reader, reader.uint32());
    };

    /**
     * Verifies a UserEntry message.
     * @function verify
     * @memberof UserEntry
     * @static
     * @param {Object.<string,*>} message Plain object to verify
     * @returns {string|null} `null` if valid, otherwise the reason why it is not
     */
    UserEntry.verify = function verify(message) {
        if (typeof message !== "object" || message === null)
            return "object expected";
        {
            var error = $root.UserId.verify(message.user);
            if (error)
                return "user." + error;
        }
        if (message.clients != null && message.hasOwnProperty("clients")) {
            if (!Array.isArray(message.clients))
                return "clients: array expected";
            for (var i = 0; i < message.clients.length; ++i) {
                var error = $root.ClientEntry.verify(message.clients[i]);
                if (error)
                    return "clients." + error;
            }
        }
        return null;
    };

    /**
     * Creates a UserEntry message from a plain object. Also converts values to their respective internal types.
     * @function fromObject
     * @memberof UserEntry
     * @static
     * @param {Object.<string,*>} object Plain object
     * @returns {UserEntry} UserEntry
     */
    UserEntry.fromObject = function fromObject(object) {
        if (object instanceof $root.UserEntry)
            return object;
        var message = new $root.UserEntry();
        if (object.user != null) {
            if (typeof object.user !== "object")
                throw TypeError(".UserEntry.user: object expected");
            message.user = $root.UserId.fromObject(object.user);
        }
        if (object.clients) {
            if (!Array.isArray(object.clients))
                throw TypeError(".UserEntry.clients: array expected");
            message.clients = [];
            for (var i = 0; i < object.clients.length; ++i) {
                if (typeof object.clients[i] !== "object")
                    throw TypeError(".UserEntry.clients: object expected");
                message.clients[i] = $root.ClientEntry.fromObject(object.clients[i]);
            }
        }
        return message;
    };

    /**
     * Creates a plain object from a UserEntry message. Also converts values to other types if specified.
     * @function toObject
     * @memberof UserEntry
     * @static
     * @param {UserEntry} message UserEntry
     * @param {$protobuf.IConversionOptions} [options] Conversion options
     * @returns {Object.<string,*>} Plain object
     */
    UserEntry.toObject = function toObject(message, options) {
        if (!options)
            options = {};
        var object = {};
        if (options.arrays || options.defaults)
            object.clients = [];
        if (options.defaults)
            object.user = null;
        if (message.user != null && message.hasOwnProperty("user"))
            object.user = $root.UserId.toObject(message.user, options);
        if (message.clients && message.clients.length) {
            object.clients = [];
            for (var j = 0; j < message.clients.length; ++j)
                object.clients[j] = $root.ClientEntry.toObject(message.clients[j], options);
        }
        return object;
    };

    /**
     * Converts this UserEntry to JSON.
     * @function toJSON
     * @memberof UserEntry
     * @instance
     * @returns {Object.<string,*>} JSON object
     */
    UserEntry.prototype.toJSON = function toJSON() {
        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
    };

    return UserEntry;
})();

$root.NewOtrMessage = (function() {

    /**
     * Properties of a NewOtrMessage.
     * @exports INewOtrMessage
     * @interface INewOtrMessage
     * @property {IClientId} sender NewOtrMessage sender
     * @property {Array.<IUserEntry>|null} [recipients] NewOtrMessage recipients
     * @property {boolean|null} [nativePush] NewOtrMessage nativePush
     * @property {Uint8Array|null} [blob] NewOtrMessage blob
     * @property {NewOtrMessage.Priority|null} [nativePriority] NewOtrMessage nativePriority
     * @property {boolean|null} [transient] NewOtrMessage transient
     * @property {Array.<IUserId>|null} [reportMissing] NewOtrMessage reportMissing
     */

    /**
     * Constructs a new NewOtrMessage.
     * @exports NewOtrMessage
     * @classdesc Represents a NewOtrMessage.
     * @implements INewOtrMessage
     * @constructor
     * @param {INewOtrMessage=} [properties] Properties to set
     */
    function NewOtrMessage(properties) {
        this.recipients = [];
        this.reportMissing = [];
        if (properties)
            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                if (properties[keys[i]] != null)
                    this[keys[i]] = properties[keys[i]];
    }

    /**
     * NewOtrMessage sender.
     * @member {IClientId} sender
     * @memberof NewOtrMessage
     * @instance
     */
    NewOtrMessage.prototype.sender = null;

    /**
     * NewOtrMessage recipients.
     * @member {Array.<IUserEntry>} recipients
     * @memberof NewOtrMessage
     * @instance
     */
    NewOtrMessage.prototype.recipients = $util.emptyArray;

    /**
     * NewOtrMessage nativePush.
     * @member {boolean} nativePush
     * @memberof NewOtrMessage
     * @instance
     */
    NewOtrMessage.prototype.nativePush = true;

    /**
     * NewOtrMessage blob.
     * @member {Uint8Array} blob
     * @memberof NewOtrMessage
     * @instance
     */
    NewOtrMessage.prototype.blob = $util.newBuffer([]);

    /**
     * NewOtrMessage nativePriority.
     * @member {NewOtrMessage.Priority} nativePriority
     * @memberof NewOtrMessage
     * @instance
     */
    NewOtrMessage.prototype.nativePriority = 1;

    /**
     * NewOtrMessage transient.
     * @member {boolean} transient
     * @memberof NewOtrMessage
     * @instance
     */
    NewOtrMessage.prototype.transient = false;

    /**
     * NewOtrMessage reportMissing.
     * @member {Array.<IUserId>} reportMissing
     * @memberof NewOtrMessage
     * @instance
     */
    NewOtrMessage.prototype.reportMissing = $util.emptyArray;

    /**
     * Creates a new NewOtrMessage instance using the specified properties.
     * @function create
     * @memberof NewOtrMessage
     * @static
     * @param {INewOtrMessage=} [properties] Properties to set
     * @returns {NewOtrMessage} NewOtrMessage instance
     */
    NewOtrMessage.create = function create(properties) {
        return new NewOtrMessage(properties);
    };

    /**
     * Encodes the specified NewOtrMessage message. Does not implicitly {@link NewOtrMessage.verify|verify} messages.
     * @function encode
     * @memberof NewOtrMessage
     * @static
     * @param {INewOtrMessage} message NewOtrMessage message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    NewOtrMessage.encode = function encode(message, writer) {
        if (!writer)
            writer = $Writer.create();
        $root.ClientId.encode(message.sender, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
        if (message.recipients != null && message.recipients.length)
            for (var i = 0; i < message.recipients.length; ++i)
                $root.UserEntry.encode(message.recipients[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
        if (message.nativePush != null && Object.hasOwnProperty.call(message, "nativePush"))
            writer.uint32(/* id 3, wireType 0 =*/24).bool(message.nativePush);
        if (message.blob != null && Object.hasOwnProperty.call(message, "blob"))
            writer.uint32(/* id 4, wireType 2 =*/34).bytes(message.blob);
        if (message.nativePriority != null && Object.hasOwnProperty.call(message, "nativePriority"))
            writer.uint32(/* id 5, wireType 0 =*/40).int32(message.nativePriority);
        if (message.transient != null && Object.hasOwnProperty.call(message, "transient"))
            writer.uint32(/* id 6, wireType 0 =*/48).bool(message.transient);
        if (message.reportMissing != null && message.reportMissing.length)
            for (var i = 0; i < message.reportMissing.length; ++i)
                $root.UserId.encode(message.reportMissing[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
        return writer;
    };

    /**
     * Encodes the specified NewOtrMessage message, length delimited. Does not implicitly {@link NewOtrMessage.verify|verify} messages.
     * @function encodeDelimited
     * @memberof NewOtrMessage
     * @static
     * @param {INewOtrMessage} message NewOtrMessage message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    NewOtrMessage.encodeDelimited = function encodeDelimited(message, writer) {
        return this.encode(message, writer).ldelim();
    };

    /**
     * Decodes a NewOtrMessage message from the specified reader or buffer.
     * @function decode
     * @memberof NewOtrMessage
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @param {number} [length] Message length if known beforehand
     * @returns {NewOtrMessage} NewOtrMessage
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    NewOtrMessage.decode = function decode(reader, length) {
        if (!(reader instanceof $Reader))
            reader = $Reader.create(reader);
        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.NewOtrMessage();
        while (reader.pos < end) {
            var tag = reader.uint32();
            switch (tag >>> 3) {
            case 1:
                message.sender = $root.ClientId.decode(reader, reader.uint32());
                break;
            case 2:
                if (!(message.recipients && message.recipients.length))
                    message.recipients = [];
                message.recipients.push($root.UserEntry.decode(reader, reader.uint32()));
                break;
            case 3:
                message.nativePush = reader.bool();
                break;
            case 4:
                message.blob = reader.bytes();
                break;
            case 5:
                message.nativePriority = reader.int32();
                break;
            case 6:
                message.transient = reader.bool();
                break;
            case 7:
                if (!(message.reportMissing && message.reportMissing.length))
                    message.reportMissing = [];
                message.reportMissing.push($root.UserId.decode(reader, reader.uint32()));
                break;
            default:
                reader.skipType(tag & 7);
                break;
            }
        }
        if (!message.hasOwnProperty("sender"))
            throw $util.ProtocolError("missing required 'sender'", { instance: message });
        return message;
    };

    /**
     * Decodes a NewOtrMessage message from the specified reader or buffer, length delimited.
     * @function decodeDelimited
     * @memberof NewOtrMessage
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @returns {NewOtrMessage} NewOtrMessage
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    NewOtrMessage.decodeDelimited = function decodeDelimited(reader) {
        if (!(reader instanceof $Reader))
            reader = new $Reader(reader);
        return this.decode(reader, reader.uint32());
    };

    /**
     * Verifies a NewOtrMessage message.
     * @function verify
     * @memberof NewOtrMessage
     * @static
     * @param {Object.<string,*>} message Plain object to verify
     * @returns {string|null} `null` if valid, otherwise the reason why it is not
     */
    NewOtrMessage.verify = function verify(message) {
        if (typeof message !== "object" || message === null)
            return "object expected";
        {
            var error = $root.ClientId.verify(message.sender);
            if (error)
                return "sender." + error;
        }
        if (message.recipients != null && message.hasOwnProperty("recipients")) {
            if (!Array.isArray(message.recipients))
                return "recipients: array expected";
            for (var i = 0; i < message.recipients.length; ++i) {
                var error = $root.UserEntry.verify(message.recipients[i]);
                if (error)
                    return "recipients." + error;
            }
        }
        if (message.nativePush != null && message.hasOwnProperty("nativePush"))
            if (typeof message.nativePush !== "boolean")
                return "nativePush: boolean expected";
        if (message.blob != null && message.hasOwnProperty("blob"))
            if (!(message.blob && typeof message.blob.length === "number" || $util.isString(message.blob)))
                return "blob: buffer expected";
        if (message.nativePriority != null && message.hasOwnProperty("nativePriority"))
            switch (message.nativePriority) {
            default:
                return "nativePriority: enum value expected";
            case 1:
            case 2:
                break;
            }
        if (message.transient != null && message.hasOwnProperty("transient"))
            if (typeof message.transient !== "boolean")
                return "transient: boolean expected";
        if (message.reportMissing != null && message.hasOwnProperty("reportMissing")) {
            if (!Array.isArray(message.reportMissing))
                return "reportMissing: array expected";
            for (var i = 0; i < message.reportMissing.length; ++i) {
                var error = $root.UserId.verify(message.reportMissing[i]);
                if (error)
                    return "reportMissing." + error;
            }
        }
        return null;
    };

    /**
     * Creates a NewOtrMessage message from a plain object. Also converts values to their respective internal types.
     * @function fromObject
     * @memberof NewOtrMessage
     * @static
     * @param {Object.<string,*>} object Plain object
     * @returns {NewOtrMessage} NewOtrMessage
     */
    NewOtrMessage.fromObject = function fromObject(object) {
        if (object instanceof $root.NewOtrMessage)
            return object;
        var message = new $root.NewOtrMessage();
        if (object.sender != null) {
            if (typeof object.sender !== "object")
                throw TypeError(".NewOtrMessage.sender: object expected");
            message.sender = $root.ClientId.fromObject(object.sender);
        }
        if (object.recipients) {
            if (!Array.isArray(object.recipients))
                throw TypeError(".NewOtrMessage.recipients: array expected");
            message.recipients = [];
            for (var i = 0; i < object.recipients.length; ++i) {
                if (typeof object.recipients[i] !== "object")
                    throw TypeError(".NewOtrMessage.recipients: object expected");
                message.recipients[i] = $root.UserEntry.fromObject(object.recipients[i]);
            }
        }
        if (object.nativePush != null)
            message.nativePush = Boolean(object.nativePush);
        if (object.blob != null)
            if (typeof object.blob === "string")
                $util.base64.decode(object.blob, message.blob = $util.newBuffer($util.base64.length(object.blob)), 0);
            else if (object.blob.length)
                message.blob = object.blob;
        switch (object.nativePriority) {
        case "LOW_PRIORITY":
        case 1:
            message.nativePriority = 1;
            break;
        case "HIGH_PRIORITY":
        case 2:
            message.nativePriority = 2;
            break;
        }
        if (object.transient != null)
            message.transient = Boolean(object.transient);
        if (object.reportMissing) {
            if (!Array.isArray(object.reportMissing))
                throw TypeError(".NewOtrMessage.reportMissing: array expected");
            message.reportMissing = [];
            for (var i = 0; i < object.reportMissing.length; ++i) {
                if (typeof object.reportMissing[i] !== "object")
                    throw TypeError(".NewOtrMessage.reportMissing: object expected");
                message.reportMissing[i] = $root.UserId.fromObject(object.reportMissing[i]);
            }
        }
        return message;
    };

    /**
     * Creates a plain object from a NewOtrMessage message. Also converts values to other types if specified.
     * @function toObject
     * @memberof NewOtrMessage
     * @static
     * @param {NewOtrMessage} message NewOtrMessage
     * @param {$protobuf.IConversionOptions} [options] Conversion options
     * @returns {Object.<string,*>} Plain object
     */
    NewOtrMessage.toObject = function toObject(message, options) {
        if (!options)
            options = {};
        var object = {};
        if (options.arrays || options.defaults) {
            object.recipients = [];
            object.reportMissing = [];
        }
        if (options.defaults) {
            object.sender = null;
            object.nativePush = true;
            if (options.bytes === String)
                object.blob = "";
            else {
                object.blob = [];
                if (options.bytes !== Array)
                    object.blob = $util.newBuffer(object.blob);
            }
            object.nativePriority = options.enums === String ? "LOW_PRIORITY" : 1;
            object.transient = false;
        }
        if (message.sender != null && message.hasOwnProperty("sender"))
            object.sender = $root.ClientId.toObject(message.sender, options);
        if (message.recipients && message.recipients.length) {
            object.recipients = [];
            for (var j = 0; j < message.recipients.length; ++j)
                object.recipients[j] = $root.UserEntry.toObject(message.recipients[j], options);
        }
        if (message.nativePush != null && message.hasOwnProperty("nativePush"))
            object.nativePush = message.nativePush;
        if (message.blob != null && message.hasOwnProperty("blob"))
            object.blob = options.bytes === String ? $util.base64.encode(message.blob, 0, message.blob.length) : options.bytes === Array ? Array.prototype.slice.call(message.blob) : message.blob;
        if (message.nativePriority != null && message.hasOwnProperty("nativePriority"))
            object.nativePriority = options.enums === String ? $root.NewOtrMessage.Priority[message.nativePriority] : message.nativePriority;
        if (message.transient != null && message.hasOwnProperty("transient"))
            object.transient = message.transient;
        if (message.reportMissing && message.reportMissing.length) {
            object.reportMissing = [];
            for (var j = 0; j < message.reportMissing.length; ++j)
                object.reportMissing[j] = $root.UserId.toObject(message.reportMissing[j], options);
        }
        return object;
    };

    /**
     * Converts this NewOtrMessage to JSON.
     * @function toJSON
     * @memberof NewOtrMessage
     * @instance
     * @returns {Object.<string,*>} JSON object
     */
    NewOtrMessage.prototype.toJSON = function toJSON() {
        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
    };

    /**
     * Priority enum.
     * @name NewOtrMessage.Priority
     * @enum {number}
     * @property {number} LOW_PRIORITY=1 LOW_PRIORITY value
     * @property {number} HIGH_PRIORITY=2 HIGH_PRIORITY value
     */
    NewOtrMessage.Priority = (function() {
        var valuesById = {}, values = Object.create(valuesById);
        values[valuesById[1] = "LOW_PRIORITY"] = 1;
        values[valuesById[2] = "HIGH_PRIORITY"] = 2;
        return values;
    })();

    return NewOtrMessage;
})();

$root.OtrAssetMeta = (function() {

    /**
     * Properties of an OtrAssetMeta.
     * @exports IOtrAssetMeta
     * @interface IOtrAssetMeta
     * @property {IClientId} sender OtrAssetMeta sender
     * @property {Array.<IUserEntry>|null} [recipients] OtrAssetMeta recipients
     * @property {boolean|null} [isInline] OtrAssetMeta isInline
     * @property {boolean|null} [nativePush] OtrAssetMeta nativePush
     */

    /**
     * Constructs a new OtrAssetMeta.
     * @exports OtrAssetMeta
     * @classdesc Represents an OtrAssetMeta.
     * @implements IOtrAssetMeta
     * @constructor
     * @param {IOtrAssetMeta=} [properties] Properties to set
     */
    function OtrAssetMeta(properties) {
        this.recipients = [];
        if (properties)
            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                if (properties[keys[i]] != null)
                    this[keys[i]] = properties[keys[i]];
    }

    /**
     * OtrAssetMeta sender.
     * @member {IClientId} sender
     * @memberof OtrAssetMeta
     * @instance
     */
    OtrAssetMeta.prototype.sender = null;

    /**
     * OtrAssetMeta recipients.
     * @member {Array.<IUserEntry>} recipients
     * @memberof OtrAssetMeta
     * @instance
     */
    OtrAssetMeta.prototype.recipients = $util.emptyArray;

    /**
     * OtrAssetMeta isInline.
     * @member {boolean} isInline
     * @memberof OtrAssetMeta
     * @instance
     */
    OtrAssetMeta.prototype.isInline = false;

    /**
     * OtrAssetMeta nativePush.
     * @member {boolean} nativePush
     * @memberof OtrAssetMeta
     * @instance
     */
    OtrAssetMeta.prototype.nativePush = true;

    /**
     * Creates a new OtrAssetMeta instance using the specified properties.
     * @function create
     * @memberof OtrAssetMeta
     * @static
     * @param {IOtrAssetMeta=} [properties] Properties to set
     * @returns {OtrAssetMeta} OtrAssetMeta instance
     */
    OtrAssetMeta.create = function create(properties) {
        return new OtrAssetMeta(properties);
    };

    /**
     * Encodes the specified OtrAssetMeta message. Does not implicitly {@link OtrAssetMeta.verify|verify} messages.
     * @function encode
     * @memberof OtrAssetMeta
     * @static
     * @param {IOtrAssetMeta} message OtrAssetMeta message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    OtrAssetMeta.encode = function encode(message, writer) {
        if (!writer)
            writer = $Writer.create();
        $root.ClientId.encode(message.sender, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
        if (message.recipients != null && message.recipients.length)
            for (var i = 0; i < message.recipients.length; ++i)
                $root.UserEntry.encode(message.recipients[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
        if (message.isInline != null && Object.hasOwnProperty.call(message, "isInline"))
            writer.uint32(/* id 3, wireType 0 =*/24).bool(message.isInline);
        if (message.nativePush != null && Object.hasOwnProperty.call(message, "nativePush"))
            writer.uint32(/* id 4, wireType 0 =*/32).bool(message.nativePush);
        return writer;
    };

    /**
     * Encodes the specified OtrAssetMeta message, length delimited. Does not implicitly {@link OtrAssetMeta.verify|verify} messages.
     * @function encodeDelimited
     * @memberof OtrAssetMeta
     * @static
     * @param {IOtrAssetMeta} message OtrAssetMeta message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    OtrAssetMeta.encodeDelimited = function encodeDelimited(message, writer) {
        return this.encode(message, writer).ldelim();
    };

    /**
     * Decodes an OtrAssetMeta message from the specified reader or buffer.
     * @function decode
     * @memberof OtrAssetMeta
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @param {number} [length] Message length if known beforehand
     * @returns {OtrAssetMeta} OtrAssetMeta
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    OtrAssetMeta.decode = function decode(reader, length) {
        if (!(reader instanceof $Reader))
            reader = $Reader.create(reader);
        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.OtrAssetMeta();
        while (reader.pos < end) {
            var tag = reader.uint32();
            switch (tag >>> 3) {
            case 1:
                message.sender = $root.ClientId.decode(reader, reader.uint32());
                break;
            case 2:
                if (!(message.recipients && message.recipients.length))
                    message.recipients = [];
                message.recipients.push($root.UserEntry.decode(reader, reader.uint32()));
                break;
            case 3:
                message.isInline = reader.bool();
                break;
            case 4:
                message.nativePush = reader.bool();
                break;
            default:
                reader.skipType(tag & 7);
                break;
            }
        }
        if (!message.hasOwnProperty("sender"))
            throw $util.ProtocolError("missing required 'sender'", { instance: message });
        return message;
    };

    /**
     * Decodes an OtrAssetMeta message from the specified reader or buffer, length delimited.
     * @function decodeDelimited
     * @memberof OtrAssetMeta
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @returns {OtrAssetMeta} OtrAssetMeta
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    OtrAssetMeta.decodeDelimited = function decodeDelimited(reader) {
        if (!(reader instanceof $Reader))
            reader = new $Reader(reader);
        return this.decode(reader, reader.uint32());
    };

    /**
     * Verifies an OtrAssetMeta message.
     * @function verify
     * @memberof OtrAssetMeta
     * @static
     * @param {Object.<string,*>} message Plain object to verify
     * @returns {string|null} `null` if valid, otherwise the reason why it is not
     */
    OtrAssetMeta.verify = function verify(message) {
        if (typeof message !== "object" || message === null)
            return "object expected";
        {
            var error = $root.ClientId.verify(message.sender);
            if (error)
                return "sender." + error;
        }
        if (message.recipients != null && message.hasOwnProperty("recipients")) {
            if (!Array.isArray(message.recipients))
                return "recipients: array expected";
            for (var i = 0; i < message.recipients.length; ++i) {
                var error = $root.UserEntry.verify(message.recipients[i]);
                if (error)
                    return "recipients." + error;
            }
        }
        if (message.isInline != null && message.hasOwnProperty("isInline"))
            if (typeof message.isInline !== "boolean")
                return "isInline: boolean expected";
        if (message.nativePush != null && message.hasOwnProperty("nativePush"))
            if (typeof message.nativePush !== "boolean")
                return "nativePush: boolean expected";
        return null;
    };

    /**
     * Creates an OtrAssetMeta message from a plain object. Also converts values to their respective internal types.
     * @function fromObject
     * @memberof OtrAssetMeta
     * @static
     * @param {Object.<string,*>} object Plain object
     * @returns {OtrAssetMeta} OtrAssetMeta
     */
    OtrAssetMeta.fromObject = function fromObject(object) {
        if (object instanceof $root.OtrAssetMeta)
            return object;
        var message = new $root.OtrAssetMeta();
        if (object.sender != null) {
            if (typeof object.sender !== "object")
                throw TypeError(".OtrAssetMeta.sender: object expected");
            message.sender = $root.ClientId.fromObject(object.sender);
        }
        if (object.recipients) {
            if (!Array.isArray(object.recipients))
                throw TypeError(".OtrAssetMeta.recipients: array expected");
            message.recipients = [];
            for (var i = 0; i < object.recipients.length; ++i) {
                if (typeof object.recipients[i] !== "object")
                    throw TypeError(".OtrAssetMeta.recipients: object expected");
                message.recipients[i] = $root.UserEntry.fromObject(object.recipients[i]);
            }
        }
        if (object.isInline != null)
            message.isInline = Boolean(object.isInline);
        if (object.nativePush != null)
            message.nativePush = Boolean(object.nativePush);
        return message;
    };

    /**
     * Creates a plain object from an OtrAssetMeta message. Also converts values to other types if specified.
     * @function toObject
     * @memberof OtrAssetMeta
     * @static
     * @param {OtrAssetMeta} message OtrAssetMeta
     * @param {$protobuf.IConversionOptions} [options] Conversion options
     * @returns {Object.<string,*>} Plain object
     */
    OtrAssetMeta.toObject = function toObject(message, options) {
        if (!options)
            options = {};
        var object = {};
        if (options.arrays || options.defaults)
            object.recipients = [];
        if (options.defaults) {
            object.sender = null;
            object.isInline = false;
            object.nativePush = true;
        }
        if (message.sender != null && message.hasOwnProperty("sender"))
            object.sender = $root.ClientId.toObject(message.sender, options);
        if (message.recipients && message.recipients.length) {
            object.recipients = [];
            for (var j = 0; j < message.recipients.length; ++j)
                object.recipients[j] = $root.UserEntry.toObject(message.recipients[j], options);
        }
        if (message.isInline != null && message.hasOwnProperty("isInline"))
            object.isInline = message.isInline;
        if (message.nativePush != null && message.hasOwnProperty("nativePush"))
            object.nativePush = message.nativePush;
        return object;
    };

    /**
     * Converts this OtrAssetMeta to JSON.
     * @function toJSON
     * @memberof OtrAssetMeta
     * @instance
     * @returns {Object.<string,*>} JSON object
     */
    OtrAssetMeta.prototype.toJSON = function toJSON() {
        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
    };

    return OtrAssetMeta;
})();

module.exports = $root;
